﻿<CascadingValue Value="@this" Name="Carousel">
    <div id="carousel-indicator" class="carousel slide" data-ride="carousel">
        <ol class="carousel-indicators">
            @for ( int i = 0; i < Count; i++ ) {
                <li data-target="#carousel-indicator" data-slide-to="@i" class="@( i == 0 ? "active" : "" )"></li>
            }
        </ol>
        <div class="carousel-inner">
            @ChildContent
        </div>
        <a class="carousel-control-prev" href="#carousel-indicator" role="button" data-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="sr-only">Previous</span>
        </a>
        <a class="carousel-control-next" href="#carousel-indicator" role="button" data-slide="next">
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="sr-only">Next</span>
        </a>
    </div>
</CascadingValue>

@code {
    [Parameter]
    public RenderFragment ChildContent { get; set; }

    private int Count { get; set; }

    protected async override Task OnParametersSetAsync( ) {
        await base.OnParametersSetAsync( );
    }

    public int Register( ) {
        Count++;
        StateHasChanged( );
        return Count;
    }
}